
import  java.io.Serializable;

public class
Complex implements Cloneable, Serializable {

    public    static final Complex I =  new Complex(0.0, 1.0);
    private                double  re;
    private                double  im;


    public Complex () {   this(0.0, 0.0);  }

    public Complex (double re) {  this(re, 0.0);  }

    public Complex (Complex z) {  this(z.re, z.im); }

    public Complex (double re, double im) { this.re =  re; this.im =  im; }

    //........................

    public boolean equals (Complex z, double tolerance) {
       double p1 = re - z.re,  p2 = im - z.im;
       return  Math.sqrt( p1*p1 + p2*p2 ) <= tolerance;
    }

    public double  real() {  return  re; }

    public double image() { return  im; }

    public double norm() { return  (re*re) + (im*im); }

    public double arg() {  return  Math.atan2(im, re); }

    public Complex  conj() { return  cart(re, -im); }

    // ..................

    public Complex add (Complex z) { return  cart(re + z.re, im + z.im); }

    public Complex add (double d) { return  cart(re + d, im); }

    public Complex sub (Complex z) { return  cart(re - z.re, im - z.im); }

    public Complex sub (double d) { return  cart(re - d, im); }

    public Complex mul (Complex z) {
        return  cart( (re*z.re) - (im*z.im), (re*z.im) + (im*z.re) );
    }

    public Complex mul (double d) { return  cart( re*d, im*d ); }

    public Complex div (Complex z) {
        double d=z.re*z.re+z.im*z.im;
        double _re=(re*z.re+im*z.im)/d;
        double _im=(im*z.re-re*z.im)/d;
        return new Complex( _re, _im );
    }

    public Complex div (double d) {
        return new Complex(re/d, im/d);
    }

    // ..............

    public Complex exp () {
        double scalar =  Math.exp(re);
        return  cart( scalar * Math.cos(im), scalar * Math.sin(im) );
    }


    public Complex sin () {
       Complex result = null;
       // ...
       return  result;
    }

    // .............

    public static Complex cart(double re, double im) {
        return  new Complex(re, im);
    }

    public static Complex cos( Complex z ) {
       Complex result = null;
       // ...
       return  result;
    }


}
