//package subjava.proc.tests.work;

import java.io.*;
import subjava.struct.localdia.*;
import subjava.proc.debug.*;
import subjava.*;

import subjava.struct.SourceFile;

public class AllTestChecking implements DebugConstants {

   public static void main( String[] args ) {
      String listFileName = "AllTestChecking.list";
      if( args.length == 1 )  listFileName = args[0];
      boolean b = true;
      try {
         FileReader fr= new FileReader( listFileName );
         BufferedReader br= new BufferedReader( fr );
         String s=null;

         while( b  &&  (s=br.readLine())!=null ) {
            String ss=s.trim();
            System.out.println("   " + ss );
            if( !ss.startsWith( "//" ) )  b = verify( s );
         }
         br.close();
      }
      catch (IOException e) {
         System.out.println("Open List File Error (" + listFileName );
      };
      if( b )  System.out.println("Ok ");
   }

   static boolean verify( String fileName ) {
      boolean b = false;

      SyntaxErrorOutput dia = new SyntaxErrorOutput( System.out );

      int maxErr = 10;
      int debugMode = DM_EMPTY;
      try {
         dia.setMaxErrorNumber( maxErr );
         SubJava.process( dia, fileName, debugMode );
         if( dia.getErrorNumber() == 0 ) {
            b = true;
            int i = fileName.indexOf( '.' );
            String ss = fileName.substring( 0, i ) + ".java";
            File f = new File( ss );
            f.delete();
         }
      }
      catch (ManyErrorException e) {}

      return b;
   }

}